#include "cqueue.h"

CQueue::CQueue()
{
  this->size=QUEUE_DEFAULT_SIZE;
  this->data=new unsigned char[this->size];
  this->num_data=0;
  this->read_pointer=0;
  this->write_pointer=0;
}

CQueue::CQueue(int size)
{
  this->size=size;
  this->data=new unsigned char[this->size];
  this->num_data=0;
  this->read_pointer=0;
  this->write_pointer=0;
}

void CQueue::resize(int new_size)
{
}

int CQueue::read(unsigned char *data,int len)
{
  int num_data_to_end=0;

  this->queue_access.enter();
  if(len>this->num_data)
    len=this->num_data;
  num_data_to_end=this->size-this->read_pointer;
  if(num_data_to_end<len)
  {
    memcpy(data,&this->data[read_pointer],num_data_to_end);
    memcpy(&data[num_data_to_end],this->data,len-num_data_to_end);
    this->read_pointer=len-num_data_to_end;
    this->num_data-=len;
  } 
  else
  {
    memcpy(data,&this->data[this->read_pointer],len);
    this->read_pointer+=len;
    this->num_data-=len;
  }
  this->queue_access.exit();

  return len;  
}

int CQueue::write(unsigned char *data,int len)
{
  int num_data_to_end=0;
  
  this->queue_access.enter();
  if(len>(this->size-this->num_data))
    len=this->size-this->num_data;
  num_data_to_end=this->size-this->write_pointer;
  if(num_data_to_end<len)
  {
    memcpy(&this->data[this->write_pointer],data,num_data_to_end);
    memcpy(this->data,&data[num_data_to_end],len-num_data_to_end);
    this->write_pointer=len-num_data_to_end;
    this->num_data+=len;
  }
  else
  {
    memcpy(&this->data[this->write_pointer],data,len);
    this->write_pointer+=len;
    this->num_data+=len;
  }
  this->queue_access.exit();

  return len;
}

int CQueue::get_num_data(void)
{
  return this->num_data;
}

bool CQueue::is_empty(void)
{
  if(this->num_data==0)
    return true;
  else
    return false;
}

bool CQueue::is_full(void)
{
  if(this->num_data==this->size)
    return true;
  else
    return false;
}

void CQueue::flush(void)
{
  this->queue_access.enter();
  this->read_pointer=0;
  this->write_pointer=0;
  this->num_data=0;
  this->queue_access.exit();
}

CQueue::~CQueue()
{
  if(this->data!=NULL)
  {
    delete[] this->data;
    this->data=NULL;
  }
  this->num_data=0;
  this->read_pointer=0;
  this->write_pointer=0;
}

